#include <iostream>
#include <fstream>
#include <random>
#include <regex>
#include <ctime>

using namespace std;

int main(int argc, char** argv)
{
    if(argc != 3 || !regex_match(argv[1], regex("[0-9]+")))
    {
        cout << "Usage: " << argv[0] << " SIZE FILE_NAME\n";
        return 1;
    }
    
    int size = atoi(argv[1]);
    
    
    /* В windows функция rand генерирует числа от 0 до 32767,
     * поэтому для генерации чисел от 0 до 1'000'000 в windows
     * используется default_random_engine.
     */
    //default_random_engine generator(time(nullptr));
    //uniform_int_distribution<int> distribution(0,1000000);
    
    // Linux
    srand(time(nullptr));
    
    ofstream fout(argv[2]);
    if(!fout.is_open())
    {
        cout << "Couldn't create file " << argv[2] << "\n";
        return 1;
    }
    fout << size << "\n";
    for(int i=0; i < size; ++i)
    {
        for(int j=0; j < size; ++j)
        {
            if(i == j)
                fout << "-1 ";
            else
            {
                // Windows
                //fout << distribution(generator) << " ";
                
                // Linux
                fout << rand() % 1000001 << " ";
            }
        }
        fout << "\n";
    }
    fout.close();
    return 0;
}
